// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/ValueReader.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;


@SuppressWarnings("fallthrough")
class ValueReader {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0, 0
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\u10fe\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\40\0\1\1\15\0\1\2\1\0\1\3\1\4\1\5"+
    "\1\6\1\7\1\10\1\11\1\12\1\13\1\14\7\0"+
    "\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24"+
    "\1\25\2\24\1\26\1\27\1\30\1\31\1\32\1\33"+
    "\1\34\1\35\1\36\1\37\1\40\1\24\1\41\1\24"+
    "\1\42\3\0\1\43\2\0\1\44\1\16\1\17\1\20"+
    "\1\21\1\22\1\23\1\24\1\45\2\24\1\26\1\27"+
    "\1\30\1\46\1\32\1\33\1\34\1\35\1\36\1\37"+
    "\1\47\1\24\1\50\1\24\1\42\57\0\1\43\5\0"+
    "\1\43\11\0\1\43\165\0\2\51\115\0\1\52\u0180\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[768];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\1\0\1\1\12\2\5\3\1\4\10\3\1\5\1\6"+
    "\1\4\1\5\1\6\1\4\1\1\12\2\1\7\6\2"+
    "\1\10\1\11\1\12\1\13\1\14\1\15\1\16\1\17"+
    "\5\3\1\0\5\3\1\0\1\20\1\12\1\17\1\20"+
    "\17\3\1\14\1\3\1\0\1\21\1\22\2\23\1\0"+
    "\1\24\1\21\1\25\1\26\1\27\1\22\1\30\1\31"+
    "\1\32\1\33\1\34\1\35\1\36\1\37\1\40\1\41"+
    "\3\3\1\1\1\42\5\3\1\0\1\43\1\1\2\3"+
    "\1\1\5\3\1\0\2\3\1\0\7\3\1\0\2\3"+
    "\1\44\5\3\1\15\1\0\1\25\1\30\1\35\6\0"+
    "\1\45\3\0\1\1\6\0\1\1\41\0\1\31\1\36"+
    "\35\0\1\46\24\0\1\47\7\0\2\50\1\0\1\51"+
    "\3\0\1\52\13\0\1\53\16\0\1\54\24\0\1\55"+
    "\2\0\1\56\1\57\50\0\1\60\1\0\1\61\15\0"+
    "\1\62\1\63\10\0\1\64\3\0\1\65\1\66\1\67"+
    "\15\0\1\70\1\71\1\72\3\0\1\73\3\0\1\74"+
    "\1\75\30\0\1\76\1\77\16\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[468];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\53\0\126\0\201\0\254\0\327\0\u0102\0\u012d"+
    "\0\u0158\0\u0183\0\u01ae\0\u01d9\0\u0204\0\u022f\0\u025a\0\u0285"+
    "\0\u02b0\0\u02db\0\u0306\0\u0331\0\u035c\0\u0387\0\u03b2\0\u03dd"+
    "\0\u0408\0\u0433\0\u045e\0\u0489\0\u04b4\0\u04df\0\u050a\0\u0535"+
    "\0\u0560\0\u058b\0\u05b6\0\u05e1\0\u060c\0\u0637\0\u0662\0\u068d"+
    "\0\u06b8\0\u06e3\0\u070e\0\53\0\u0739\0\u0764\0\u078f\0\u07ba"+
    "\0\u07e5\0\u0810\0\53\0\53\0\53\0\53\0\53\0\53"+
    "\0\53\0\53\0\u083b\0\u0866\0\u0891\0\u08bc\0\u08e7\0\u0912"+
    "\0\u093d\0\u0968\0\u0993\0\u09be\0\u09e9\0\u0a14\0\u0a3f\0\u083b"+
    "\0\u083b\0\u0a6a\0\u0a95\0\u0ac0\0\u0aeb\0\u0b16\0\u0b41\0\u0b6c"+
    "\0\u0b97\0\u0bc2\0\u0bed\0\u0c18\0\u0c43\0\u0c6e\0\u0c99\0\u0cc4"+
    "\0\u0cef\0\u0d1a\0\u0d45\0\u0d70\0\u0d9b\0\u0dc6\0\u0df1\0\u083b"+
    "\0\u0e1c\0\53\0\53\0\53\0\53\0\53\0\53\0\53"+
    "\0\53\0\53\0\53\0\53\0\53\0\53\0\53\0\53"+
    "\0\53\0\53\0\u0e47\0\u0e72\0\u0e9d\0\53\0\u0ec8\0\u0ef3"+
    "\0\u0f1e\0\u0f49\0\u0f74\0\u0f1e\0\53\0\u0f9f\0\u0fca\0\u0ff5"+
    "\0\u1020\0\u104b\0\u1076\0\u10a1\0\u10cc\0\u10f7\0\u10cc\0\u1122"+
    "\0\u114d\0\u114d\0\u1178\0\u11a3\0\u11ce\0\u11f9\0\u1224\0\u124f"+
    "\0\u127a\0\u1224\0\u12a5\0\u12d0\0\u12fb\0\u1326\0\u1351\0\u137c"+
    "\0\u13a7\0\u13d2\0\u13fd\0\u13d2\0\u1428\0\u1453\0\u147e\0\u1178"+
    "\0\u11a3\0\u11ce\0\u11f9\0\u124f\0\u127a\0\53\0\u14a9\0\u14d4"+
    "\0\u14ff\0\u152a\0\u1555\0\u1580\0\u15ab\0\u15d6\0\u1601\0\u162c"+
    "\0\u1657\0\u1682\0\u16ad\0\u16d8\0\u1703\0\u172e\0\u1759\0\u1784"+
    "\0\u17af\0\u17da\0\u1805\0\u1830\0\u185b\0\u1886\0\u18b1\0\u18dc"+
    "\0\u1907\0\u1932\0\u195d\0\u1988\0\u19b3\0\u19de\0\u1a09\0\u1a34"+
    "\0\u1a5f\0\u1a8a\0\u1ab5\0\u1ae0\0\u1b0b\0\u1b36\0\u1b61\0\u1b8c"+
    "\0\u1bb7\0\u1be2\0\u1c0d\0\u1c38\0\u1c63\0\u1c8e\0\u1cb9\0\u1ce4"+
    "\0\u1d0f\0\u1d3a\0\u1d65\0\u1d90\0\u1dbb\0\u1de6\0\u1e11\0\u1e3c"+
    "\0\u1e67\0\u1e92\0\u1ebd\0\u1ee8\0\u1f13\0\u1f3e\0\u1f69\0\u1f94"+
    "\0\u1fbf\0\u1fea\0\u2015\0\u2040\0\u206b\0\u2096\0\u20c1\0\u20ec"+
    "\0\u2117\0\53\0\u2142\0\u216d\0\u2198\0\u21c3\0\u21ee\0\u2219"+
    "\0\u2244\0\u226f\0\u229a\0\u22c5\0\u22f0\0\u231b\0\u2346\0\u2371"+
    "\0\u239c\0\u23c7\0\u23f2\0\u241d\0\u2448\0\u2473\0\53\0\u249e"+
    "\0\u24c9\0\u24f4\0\u251f\0\u254a\0\u2575\0\u25a0\0\53\0\u25cb"+
    "\0\u25f6\0\u2621\0\u264c\0\u2677\0\u26a2\0\u26cd\0\u26f8\0\u2723"+
    "\0\u274e\0\u2779\0\u27a4\0\u27cf\0\u27fa\0\u2825\0\u2850\0\u287b"+
    "\0\u28a6\0\u28d1\0\u28fc\0\u2927\0\u2952\0\u297d\0\u29a8\0\u29d3"+
    "\0\u29fe\0\u2a29\0\u2a54\0\u2a7f\0\u2aaa\0\u2ad5\0\u2b00\0\u2b2b"+
    "\0\u2b56\0\u2b81\0\u2bac\0\u2bd7\0\u2c02\0\u2c2d\0\u2c58\0\u2c83"+
    "\0\u2cae\0\u2cd9\0\u2d04\0\u2d2f\0\u2d5a\0\u2d85\0\u2db0\0\u2ddb"+
    "\0\u2e06\0\u2e31\0\u2e5c\0\u2e87\0\u2eb2\0\u2edd\0\u2f08\0\u2f33"+
    "\0\53\0\53\0\u2f5e\0\u2f89\0\u2fb4\0\u2fdf\0\u300a\0\u3035"+
    "\0\u3060\0\u308b\0\u30b6\0\u30e1\0\u310c\0\u3137\0\u3162\0\u318d"+
    "\0\u31b8\0\u31e3\0\u320e\0\u3239\0\u3264\0\u328f\0\u32ba\0\u32e5"+
    "\0\u3310\0\u333b\0\u3366\0\u3391\0\u33bc\0\u33e7\0\u3412\0\u343d"+
    "\0\u3468\0\u3493\0\u34be\0\u34e9\0\u3514\0\u353f\0\u356a\0\u3595"+
    "\0\u35c0\0\u35eb\0\53\0\u3616\0\53\0\u3641\0\u366c\0\u3697"+
    "\0\u36c2\0\u36ed\0\u3718\0\u3743\0\u376e\0\u3799\0\u37c4\0\u37ef"+
    "\0\u381a\0\u3845\0\53\0\53\0\u3870\0\u389b\0\u38c6\0\u38f1"+
    "\0\u391c\0\u3947\0\u3972\0\u399d\0\u39c8\0\u39f3\0\u3a1e\0\u3a49"+
    "\0\53\0\53\0\53\0\u3a74\0\u3a9f\0\u3aca\0\u3af5\0\u3b20"+
    "\0\u3b4b\0\u3b76\0\u3ba1\0\u3bcc\0\u3bf7\0\u3c22\0\u3c4d\0\u3c78"+
    "\0\53\0\53\0\53\0\u3ca3\0\u3cce\0\u3cf9\0\53\0\u3d24"+
    "\0\u3d4f\0\u3d7a\0\53\0\53\0\u3da5\0\u3dd0\0\u3dfb\0\u3e26"+
    "\0\u3e51\0\u3e7c\0\u3ea7\0\u3ed2\0\u3efd\0\u3f28\0\u3f53\0\u3f7e"+
    "\0\u3fa9\0\u3fd4\0\u3fff\0\u402a\0\u4055\0\u4080\0\u40ab\0\u40d6"+
    "\0\u4101\0\u412c\0\u4157\0\u4182\0\53\0\53\0\u41ad\0\u41d8"+
    "\0\u4203\0\u422e\0\u4259\0\u4284\0\u42af\0\u42da\0\u4305\0\u4330"+
    "\0\u435b\0\u4386\0\u43b1\0\u43dc";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[468];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\3\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11"+
    "\1\12\1\13\1\14\1\15\1\16\1\17\1\20\4\21"+
    "\1\22\1\23\1\21\1\24\1\25\1\26\1\27\1\21"+
    "\1\30\1\31\1\32\1\33\1\34\1\21\1\2\1\15"+
    "\1\35\1\25\1\36\1\37\1\40\1\41\56\0\12\3"+
    "\41\0\1\42\1\43\1\44\1\45\1\46\1\47\1\50"+
    "\1\51\1\52\1\53\26\0\2\54\1\0\1\54\7\0"+
    "\1\55\1\56\1\57\1\60\1\61\1\62\4\3\26\0"+
    "\2\63\1\0\1\63\7\0\12\3\26\0\2\64\1\0"+
    "\1\64\7\0\12\3\26\0\2\65\1\0\1\65\7\0"+
    "\12\3\26\0\2\66\1\0\1\66\7\0\12\3\26\0"+
    "\2\67\1\0\1\67\7\0\12\3\26\0\2\70\1\0"+
    "\1\70\7\0\12\3\26\0\2\71\1\0\1\71\7\0"+
    "\12\3\26\0\2\72\1\0\1\72\21\0\11\73\1\74"+
    "\1\73\1\75\3\73\1\76\6\73\1\0\5\73\17\0"+
    "\10\73\1\77\15\73\1\0\1\73\1\77\3\73\1\100"+
    "\16\0\14\73\1\101\11\73\1\0\2\73\1\101\2\73"+
    "\17\0\4\73\1\102\3\73\1\103\3\73\1\104\5\73"+
    "\1\105\3\73\1\0\1\73\1\103\1\104\2\73\1\106"+
    "\16\0\26\73\1\0\5\73\17\0\10\73\1\107\12\73"+
    "\1\110\1\111\1\73\1\0\1\73\1\107\3\73\1\112"+
    "\16\0\4\73\1\113\21\73\1\0\5\73\4\0\1\2"+
    "\12\0\13\73\1\114\1\115\5\73\1\116\3\73\1\0"+
    "\2\73\1\115\2\73\17\0\2\73\1\117\16\73\1\120"+
    "\4\73\1\0\5\73\17\0\1\121\16\73\1\122\6\73"+
    "\1\0\1\121\4\73\17\0\22\73\1\123\3\73\1\0"+
    "\5\73\17\0\4\73\1\124\21\73\1\0\5\73\17\0"+
    "\1\125\3\73\1\126\12\73\1\127\6\73\1\0\1\125"+
    "\4\73\17\0\13\73\1\130\12\73\1\0\5\73\17\0"+
    "\4\73\1\131\3\73\1\132\15\73\1\0\1\73\1\133"+
    "\3\73\1\134\16\0\10\73\1\135\12\73\1\136\1\137"+
    "\1\73\1\0\4\73\1\140\17\0\10\73\1\107\15\73"+
    "\1\0\1\73\1\107\3\73\1\112\16\0\4\73\1\131"+
    "\3\73\1\133\15\73\1\0\1\73\1\133\3\73\1\134"+
    "\16\0\24\73\1\140\1\73\1\0\4\73\1\140\27\0"+
    "\1\112\17\0\1\112\3\0\1\112\22\0\1\141\34\0"+
    "\12\3\26\0\2\142\1\0\1\142\7\0\12\3\26\0"+
    "\2\143\1\0\1\143\7\0\12\3\26\0\2\144\1\0"+
    "\1\144\7\0\12\3\26\0\2\145\1\0\1\145\7\0"+
    "\12\3\26\0\2\146\1\0\1\146\7\0\12\3\26\0"+
    "\2\147\1\0\1\147\7\0\12\3\26\0\2\150\1\0"+
    "\1\150\7\0\12\3\26\0\2\151\1\0\1\151\7\0"+
    "\12\3\26\0\2\152\1\0\1\152\7\0\12\3\26\0"+
    "\2\153\1\0\1\153\7\0\12\3\26\0\2\154\1\0"+
    "\1\154\7\0\12\3\26\0\2\155\1\0\1\155\7\0"+
    "\12\3\26\0\2\156\1\0\1\156\7\0\12\3\26\0"+
    "\2\157\1\0\1\157\7\0\12\3\26\0\2\160\1\0"+
    "\1\160\7\0\12\3\26\0\2\161\1\0\1\161\21\0"+
    "\26\162\1\0\5\162\17\0\11\162\1\163\14\162\1\0"+
    "\5\162\17\0\13\162\1\164\12\162\1\0\5\162\17\0"+
    "\21\162\1\165\4\162\1\0\5\162\17\0\20\162\1\166"+
    "\5\162\1\0\5\162\1\0\1\166\35\0\1\166\14\0"+
    "\1\166\2\0\1\2\12\0\12\162\1\167\13\162\1\0"+
    "\5\162\17\0\2\162\1\170\23\162\1\0\5\162\17\0"+
    "\2\162\1\171\23\162\1\0\5\162\17\0\3\162\1\172"+
    "\22\162\1\0\5\162\17\0\14\162\1\173\11\162\1\0"+
    "\2\162\1\173\2\162\21\0\1\174\50\0\10\162\1\175"+
    "\15\162\1\0\1\162\1\175\3\162\1\175\26\0\1\175"+
    "\17\0\1\175\3\0\1\175\16\0\21\162\1\176\4\162"+
    "\1\0\5\162\4\0\1\2\12\0\26\162\1\0\5\162"+
    "\17\0\13\162\1\177\7\162\1\200\2\162\1\0\3\162"+
    "\1\200\1\162\17\0\12\162\1\201\13\162\1\0\5\162"+
    "\17\0\21\162\1\202\4\162\1\0\5\162\17\0\21\162"+
    "\1\203\4\162\1\0\5\162\17\0\17\162\1\204\6\162"+
    "\1\0\5\162\17\0\10\162\1\205\3\162\1\206\11\162"+
    "\1\0\1\162\1\205\1\206\2\162\1\207\16\0\1\210"+
    "\7\162\1\211\15\162\1\0\1\210\1\211\3\162\1\212"+
    "\16\0\2\162\1\213\1\214\6\162\1\215\2\162\1\216"+
    "\2\162\1\217\1\220\2\162\1\221\1\162\1\0\4\162"+
    "\1\221\1\0\1\222\15\0\1\162\1\223\15\162\1\224"+
    "\6\162\1\0\5\162\17\0\17\162\1\225\6\162\1\0"+
    "\5\162\17\0\4\162\1\226\21\162\1\0\5\162\17\0"+
    "\3\162\1\227\17\162\1\230\2\162\1\0\3\162\1\230"+
    "\1\162\17\0\13\162\1\231\12\162\1\0\5\162\17\0"+
    "\2\162\1\232\5\162\1\233\15\162\1\0\5\162\17\0"+
    "\2\162\1\232\23\162\1\0\5\162\21\0\1\234\50\0"+
    "\10\162\1\235\12\162\1\146\1\153\1\162\1\0\5\162"+
    "\17\0\10\162\1\236\15\162\1\0\5\162\17\0\10\162"+
    "\1\237\12\162\1\161\2\162\1\0\5\162\21\0\1\240"+
    "\1\241\6\0\1\242\2\0\1\243\2\0\1\222\1\244"+
    "\2\0\1\245\6\0\1\245\1\0\1\222\2\0\1\246"+
    "\16\0\1\247\52\0\1\250\33\0\1\2\22\0\1\251"+
    "\10\0\1\252\6\0\1\251\3\0\1\251\30\0\1\253"+
    "\50\0\1\254\17\0\1\254\3\0\1\254\26\0\1\255"+
    "\17\0\1\255\3\0\1\255\26\0\1\256\17\0\1\256"+
    "\3\0\1\256\21\0\1\257\17\0\1\260\6\0\1\260"+
    "\5\0\1\2\33\0\1\261\31\0\1\72\7\0\1\262"+
    "\3\0\1\72\12\0\1\72\1\262\1\72\2\0\1\262"+
    "\26\0\1\263\3\0\1\264\13\0\1\263\1\264\2\0"+
    "\1\263\3\0\1\2\16\0\1\265\56\0\1\266\3\0"+
    "\1\267\13\0\1\266\1\267\2\0\1\266\16\0\1\270"+
    "\26\0\1\270\10\0\1\2\12\0\1\271\26\0\1\271"+
    "\35\0\1\272\61\0\1\273\50\0\1\274\1\0\1\275"+
    "\44\0\1\276\53\0\1\277\14\0\1\277\31\0\1\300"+
    "\17\0\1\300\3\0\1\300\22\0\1\301\67\0\1\302"+
    "\52\0\1\303\52\0\1\304\34\0\1\305\4\0\1\306"+
    "\17\0\1\306\3\0\1\306\22\0\1\307\56\0\1\310"+
    "\17\0\1\310\3\0\1\310\2\0\1\311\16\0\1\312"+
    "\17\0\1\313\1\0\1\314\4\0\1\313\23\0\1\315"+
    "\53\0\1\316\3\0\1\317\17\0\1\317\3\0\1\317"+
    "\26\0\1\320\17\0\1\320\3\0\1\320\37\0\1\321"+
    "\41\0\1\322\17\0\1\322\3\0\1\322\26\0\1\71"+
    "\52\0\1\145\52\0\1\323\52\0\1\324\12\0\1\160"+
    "\35\0\1\325\64\0\1\326\14\0\1\326\17\0\1\327"+
    "\35\0\1\2\65\0\1\2\7\0\1\2\16\0\2\2"+
    "\3\0\1\2\22\0\1\330\5\0\1\331\40\0\1\332"+
    "\13\0\1\333\12\0\1\332\1\0\1\333\23\0\1\334"+
    "\54\0\1\335\56\0\1\336\17\0\1\336\3\0\1\336"+
    "\3\0\1\2\16\0\1\337\52\0\1\340\52\0\1\341"+
    "\51\0\1\342\66\0\1\343\37\0\1\344\51\0\1\345"+
    "\72\0\1\346\6\0\1\346\26\0\1\347\44\0\1\54"+
    "\13\0\1\54\12\0\1\54\1\0\1\54\35\0\1\350"+
    "\14\0\1\350\42\0\1\351\35\0\1\352\14\0\1\353"+
    "\34\0\1\354\12\0\1\355\2\0\1\356\1\0\1\357"+
    "\6\0\1\357\33\0\1\360\41\0\1\361\61\0\1\362"+
    "\44\0\1\363\4\0\1\364\17\0\1\364\3\0\1\364"+
    "\16\0\1\67\13\0\1\67\12\0\1\67\1\0\1\67"+
    "\31\0\1\365\17\0\1\365\3\0\1\365\22\0\1\366"+
    "\52\0\1\367\57\0\1\370\46\0\1\371\50\0\1\312"+
    "\53\0\1\372\56\0\1\373\17\0\1\373\3\0\1\373"+
    "\16\0\1\64\13\0\1\64\12\0\1\64\1\0\1\64"+
    "\31\0\1\374\17\0\1\374\3\0\1\374\20\0\1\375"+
    "\52\0\1\376\52\0\1\377\54\0\1\u0100\3\0\1\u0101"+
    "\11\0\1\u0102\5\0\1\u0101\3\0\1\u0101\22\0\1\u0103"+
    "\56\0\1\152\52\0\1\157\42\0\1\u0104\26\0\1\u0104"+
    "\43\0\1\u0105\14\0\1\u0105\31\0\1\u0106\14\0\1\u0106"+
    "\41\0\1\u0107\14\0\1\u0107\15\0\1\142\13\0\1\142"+
    "\12\0\1\142\1\0\1\142\34\0\1\u0108\4\0\1\u0109"+
    "\14\0\1\u0109\36\0\1\u010a\35\0\1\u010b\50\0\1\u010c"+
    "\52\0\1\u010d\67\0\1\u010e\53\0\1\u010f\14\0\1\u010f"+
    "\35\0\1\u0110\14\0\1\u0110\21\0\1\u0111\56\0\1\2"+
    "\3\0\1\2\13\0\2\2\2\0\1\2\36\0\1\u0112"+
    "\14\0\1\u0112\21\0\1\u0113\46\0\1\71\13\0\1\71"+
    "\12\0\1\71\1\0\1\71\40\0\1\u0114\35\0\1\u0115"+
    "\50\0\1\65\13\0\1\65\12\0\1\65\1\0\1\65"+
    "\40\0\1\u0116\47\0\1\u0117\14\0\1\u0117\25\0\1\u0118"+
    "\3\0\1\u0119\17\0\1\u0119\3\0\1\u0119\40\0\1\u011a"+
    "\30\0\1\66\13\0\1\66\12\0\1\66\1\0\1\66"+
    "\31\0\1\u011b\17\0\1\u011b\3\0\1\u011b\21\0\1\u011c"+
    "\53\0\1\u011d\52\0\1\u011e\52\0\1\u011f\60\0\1\u0120"+
    "\42\0\1\u0121\70\0\1\u0122\14\0\1\u0122\26\0\1\u0123"+
    "\46\0\1\u0124\47\0\1\u0125\52\0\1\u0126\52\0\1\u0127"+
    "\60\0\1\u0128\17\0\1\u0128\3\0\1\u0128\22\0\1\u0129"+
    "\56\0\1\u012a\17\0\1\u012a\3\0\1\u012a\36\0\1\u012b"+
    "\14\0\1\u012b\17\0\1\u012c\1\u012d\12\0\1\u012e\2\0"+
    "\1\u012f\44\0\1\u0130\57\0\1\u0131\14\0\1\u0131\36\0"+
    "\1\u0105\31\0\1\246\3\0\1\246\3\0\1\246\3\0"+
    "\1\246\12\0\3\246\2\0\1\246\27\0\1\343\54\0"+
    "\1\u0132\57\0\1\u0133\14\0\1\u0133\36\0\1\u0134\51\0"+
    "\1\u0135\14\0\1\u0135\25\0\1\u0136\17\0\1\u0136\3\0"+
    "\1\u0136\26\0\1\u0137\17\0\1\u0137\3\0\1\u0137\16\0"+
    "\1\2\3\0\1\2\22\0\1\2\7\0\1\264\16\0"+
    "\1\342\51\0\1\u0138\34\0\1\267\16\0\1\345\51\0"+
    "\1\u0139\50\0\1\u013a\26\0\1\u013a\37\0\1\u013b\14\0"+
    "\1\u013b\5\0\1\u013c\16\0\1\u013d\17\0\1\u013e\6\0"+
    "\1\u013e\37\0\1\u013f\35\0\1\u0140\52\0\1\u0141\60\0"+
    "\1\u0142\17\0\1\u0142\3\0\1\u0142\20\0\1\u0143\50\0"+
    "\1\63\13\0\1\63\12\0\1\63\1\0\1\63\41\0"+
    "\1\u0144\14\0\1\u0144\17\0\1\u0145\70\0\1\u0146\14\0"+
    "\1\u0146\15\0\1\70\13\0\1\70\12\0\1\70\1\0"+
    "\1\70\31\0\1\u0147\17\0\1\u0147\3\0\1\u0147\2\0"+
    "\1\u0148\16\0\1\305\47\0\1\u0149\3\0\1\u0149\22\0"+
    "\1\u0149\23\0\1\u014a\3\0\1\u014a\22\0\1\u014a\33\0"+
    "\1\u014b\17\0\1\u014b\3\0\1\u014b\26\0\1\u014c\17\0"+
    "\1\u014c\3\0\1\u014c\22\0\1\u014d\52\0\1\u014e\66\0"+
    "\1\u014f\14\0\1\u014f\21\0\1\u0150\56\0\1\u0151\17\0"+
    "\1\u0151\3\0\1\u0151\26\0\1\u0152\17\0\1\u0152\3\0"+
    "\1\u0152\40\0\1\u0153\52\0\1\u0154\47\0\1\u0155\37\0"+
    "\1\u0156\32\0\1\u0157\14\0\1\u0158\14\0\1\u0159\1\0"+
    "\1\u015a\1\u015b\13\0\1\u015a\31\0\1\u015c\14\0\1\u015c"+
    "\25\0\1\u015d\52\0\1\u015e\56\0\1\u015f\17\0\1\u015f"+
    "\3\0\1\u015f\22\0\1\u0160\52\0\1\u0161\56\0\1\u0162"+
    "\17\0\1\u0162\3\0\1\u0162\26\0\1\u0163\17\0\1\u0163"+
    "\3\0\1\u0163\23\0\1\343\56\0\1\u0164\44\0\1\u013d"+
    "\53\0\1\u0165\56\0\1\u0166\17\0\1\u0166\3\0\1\u0166"+
    "\21\0\1\u0167\57\0\1\u0168\17\0\1\u0168\3\0\1\u0168"+
    "\22\0\1\u0169\52\0\1\u016a\56\0\1\u016b\17\0\1\u016b"+
    "\3\0\1\u016b\26\0\1\u016c\17\0\1\u016c\3\0\1\u016c"+
    "\26\0\1\u016d\17\0\1\u016d\3\0\1\u016d\2\0\1\u016e"+
    "\16\0\1\363\53\0\1\u016f\51\0\1\305\53\0\1\u0170"+
    "\52\0\1\u0171\66\0\1\u0172\14\0\1\u0172\35\0\1\u0173"+
    "\14\0\1\u0173\25\0\1\u0174\17\0\1\u0174\3\0\1\u0174"+
    "\36\0\1\u0175\14\0\1\u0175\27\0\1\u0176\53\0\1\u0177"+
    "\43\0\1\u0178\46\0\1\u0179\26\0\1\u0179\27\0\1\u017a"+
    "\66\0\1\u017b\14\0\1\u017b\16\0\1\u0158\14\0\1\u0159"+
    "\1\0\1\u015a\1\u015b\13\0\1\u015a\25\0\1\u0161\17\0"+
    "\1\u0161\3\0\1\u0161\40\0\1\u017c\34\0\1\u017d\52\0"+
    "\1\u017e\71\0\1\u017f\6\0\1\u017f\41\0\1\u0180\51\0"+
    "\1\u0181\14\0\1\u0181\27\0\1\u0182\60\0\1\u0183\14\0"+
    "\1\u0183\35\0\1\u0184\14\0\1\u0184\21\0\1\u0185\52\0"+
    "\1\u0186\57\0\1\u0187\43\0\1\u0188\52\0\1\u0189\60\0"+
    "\1\u018a\17\0\1\u018a\3\0\1\u018a\22\0\1\u018b\66\0"+
    "\1\u018c\14\0\1\u018c\35\0\1\u018d\14\0\1\u018d\21\0"+
    "\1\u018e\60\0\1\u018f\44\0\1\u0190\51\0\1\363\67\0"+
    "\1\u0191\14\0\1\u0191\35\0\1\u0192\14\0\1\u0192\35\0"+
    "\1\u0193\14\0\1\u0193\25\0\1\u0194\17\0\1\u0194\3\0"+
    "\1\u0194\30\0\1\u0195\40\0\1\154\13\0\1\154\12\0"+
    "\1\154\1\0\1\154\37\0\1\u0196\54\0\1\u0197\14\0"+
    "\1\u0197\36\0\1\u0198\35\0\1\u0199\56\0\1\u019a\17\0"+
    "\1\u019a\3\0\1\u019a\16\0\1\u019b\7\0\1\u019c\16\0"+
    "\1\u019b\1\u019c\3\0\1\u019c\30\0\1\u019d\57\0\1\u0193"+
    "\37\0\1\u019e\67\0\1\u019f\41\0\1\u01a0\17\0\1\u01a0"+
    "\3\0\1\u01a0\16\0\1\144\13\0\1\144\12\0\1\144"+
    "\1\0\1\144\41\0\1\u01a1\14\0\1\u01a1\35\0\1\u01a2"+
    "\14\0\1\u01a2\25\0\1\u01a3\3\0\1\u01a3\13\0\2\u01a3"+
    "\2\0\1\u01a3\26\0\1\u01a4\17\0\1\u01a4\3\0\1\u01a4"+
    "\26\0\1\u01a5\17\0\1\u01a5\3\0\1\u01a5\20\0\1\u01a6"+
    "\70\0\1\u01a7\14\0\1\u01a7\25\0\1\u01a8\17\0\1\u01a8"+
    "\3\0\1\u01a8\2\0\1\u01a9\16\0\1\u01aa\67\0\1\u01ab"+
    "\14\0\1\u01ab\15\0\1\150\13\0\1\150\12\0\1\150"+
    "\1\0\1\150\41\0\1\u01ac\14\0\1\u01ac\27\0\1\u01ad"+
    "\40\0\1\143\13\0\1\143\12\0\1\143\1\0\1\143"+
    "\43\0\1\u01ae\40\0\1\u01af\17\0\1\u01af\3\0\1\u01af"+
    "\37\0\1\u01b0\51\0\1\u01b1\14\0\1\u01b1\27\0\1\u01b2"+
    "\61\0\1\u01b3\44\0\1\u01b4\43\0\1\u01b5\66\0\1\u01b6"+
    "\14\0\1\u01b6\21\0\1\u01b7\60\0\1\u01b8\44\0\1\u01b9"+
    "\52\0\1\u01ba\52\0\1\u01bb\60\0\1\u01bc\43\0\1\u01aa"+
    "\53\0\1\u0118\46\0\1\145\13\0\1\145\12\0\1\145"+
    "\1\0\1\145\25\0\1\u01bd\60\0\1\u01be\57\0\1\u01bf"+
    "\43\0\1\u01c0\17\0\1\u01c0\3\0\1\u01c0\16\0\1\155"+
    "\13\0\1\155\12\0\1\155\1\0\1\155\25\0\1\u01c1"+
    "\64\0\1\u01c2\45\0\1\u0175\51\0\1\u01c3\17\0\1\u01c3"+
    "\3\0\1\u01c3\36\0\1\u01c4\14\0\1\u01c4\15\0\1\152"+
    "\13\0\1\152\12\0\1\152\1\0\1\152\41\0\1\u01c5"+
    "\14\0\1\u01c5\35\0\1\u01c6\14\0\1\u01c6\35\0\1\u01c7"+
    "\14\0\1\u01c7\15\0\1\147\13\0\1\147\12\0\1\147"+
    "\1\0\1\147\41\0\1\u01c8\14\0\1\u01c8\15\0\1\156"+
    "\13\0\1\156\12\0\1\156\1\0\1\156\25\0\1\u01c9"+
    "\60\0\1\u01ca\57\0\1\u01c6\55\0\1\u0143\42\0\1\u01cb"+
    "\50\0\1\u01cc\17\0\1\u01cc\3\0\1\u01cc\26\0\1\u01cd"+
    "\17\0\1\u01cd\3\0\1\u01cd\26\0\1\u01ce\17\0\1\u01ce"+
    "\3\0\1\u01ce\36\0\1\u01cf\14\0\1\u01cf\15\0\1\157"+
    "\13\0\1\157\12\0\1\157\1\0\1\157\21\0\1\153"+
    "\13\0\1\153\12\0\1\153\1\0\1\153\33\0\1\u01d0"+
    "\52\0\1\u01d1\52\0\1\u01d2\50\0\1\u01d3\17\0\1\u01d3"+
    "\3\0\1\u01d3\16\0\1\151\13\0\1\151\12\0\1\151"+
    "\1\0\1\151\21\0\1\146\13\0\1\146\12\0\1\146"+
    "\1\0\1\146\21\0\1\161\13\0\1\161\12\0\1\161"+
    "\1\0\1\161\33\0\1\u01d4\40\0\1\160\13\0\1\160"+
    "\12\0\1\160\1\0\1\160\4\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[17415];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\1\0\1\11\51\1\1\11\6\1\10\11\5\1\1\0"+
    "\5\1\1\0\25\1\1\0\4\1\1\0\21\11\3\1"+
    "\1\11\5\1\1\0\1\11\11\1\1\0\2\1\1\0"+
    "\7\1\1\0\11\1\1\0\3\1\6\0\1\11\3\0"+
    "\1\1\6\0\1\1\41\0\2\1\35\0\1\11\24\0"+
    "\1\11\7\0\1\11\1\1\1\0\1\1\3\0\1\1"+
    "\13\0\1\1\16\0\1\1\24\0\1\1\2\0\2\11"+
    "\50\0\1\11\1\0\1\11\15\0\2\11\10\0\1\1"+
    "\3\0\3\11\15\0\3\11\3\0\1\11\3\0\2\11"+
    "\30\0\2\11\16\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[468];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	ValueReader() { }
	
	private String number = null;
	
	private String subnumber = null;
	
	private String letter = null;
	
	private String latin = null;
	
	private String tipoAllegato = null;
	
	String getNumber() {
	
		if(number == null) return null;
		
		if(latin != null) number += latin;
		
		return number;
	}

	String getLetter() {
	
		if(letter == null) return null;
		
		if(latin != null) letter += latin;
		
		return letter;
	}
	
	String getTipoAllegato() {
	
		if(tipoAllegato == null) return null;
		
		return tipoAllegato;
	}

	String getSubNumber() {
	
		if(subnumber == null) return null;
		
		return subnumber;
	}

	String getNumberSubNumber() {
	
		if(number == null) return null;
	
		if(subnumber == null) return number;
		
		return number + "." + subnumber;
	}

	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  ValueReader(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { 
            }
          // fall through
          case 64: break;
          case 2:
            { if(number == null)
		number = yytext();
	else
		subnumber = yytext();
            }
          // fall through
          case 65: break;
          case 3:
            { letter = yytext();
            }
          // fall through
          case 66: break;
          case 4:
            { number = "1"; letter = yytext();
            }
          // fall through
          case 67: break;
          case 5:
            { number = "5"; letter = yytext();
            }
          // fall through
          case 68: break;
          case 6:
            { number = "10"; letter = yytext();
            }
          // fall through
          case 69: break;
          case 7:
            { number = "1";
            }
          // fall through
          case 70: break;
          case 8:
            { number = "2";
            }
          // fall through
          case 71: break;
          case 9:
            { number = "3";
            }
          // fall through
          case 72: break;
          case 10:
            { number = "4";
            }
          // fall through
          case 73: break;
          case 11:
            { number = "5";
            }
          // fall through
          case 74: break;
          case 12:
            { number = "6";
            }
          // fall through
          case 75: break;
          case 13:
            { number = "7";
            }
          // fall through
          case 76: break;
          case 14:
            { number = "8";
            }
          // fall through
          case 77: break;
          case 15:
            { number = "9";
            }
          // fall through
          case 78: break;
          case 16:
            { number = "2"; letter = yytext();
            }
          // fall through
          case 79: break;
          case 17:
            { number = "11";
            }
          // fall through
          case 80: break;
          case 18:
            { number = "15";
            }
          // fall through
          case 81: break;
          case 19:
            { number = "20"; letter = yytext();
            }
          // fall through
          case 82: break;
          case 20:
            { number = "10";
            }
          // fall through
          case 83: break;
          case 21:
            { number = "12";
            }
          // fall through
          case 84: break;
          case 22:
            { number = "13";
            }
          // fall through
          case 85: break;
          case 23:
            { number = "14";
            }
          // fall through
          case 86: break;
          case 24:
            { number = "16";
            }
          // fall through
          case 87: break;
          case 25:
            { number = "17";
            }
          // fall through
          case 88: break;
          case 26:
            { number = "18";
            }
          // fall through
          case 89: break;
          case 27:
            { number = "19";
            }
          // fall through
          case 90: break;
          case 28:
            { number = "20";
            }
          // fall through
          case 91: break;
          case 29:
            { number = "21";
            }
          // fall through
          case 92: break;
          case 30:
            { number = "22";
            }
          // fall through
          case 93: break;
          case 31:
            { number = "23";
            }
          // fall through
          case 94: break;
          case 32:
            { number = "24";
            }
          // fall through
          case 95: break;
          case 33:
            { number = "25";
            }
          // fall through
          case 96: break;
          case 34:
            { latin = "-BIS";
            }
          // fall through
          case 97: break;
          case 35:
            { number = "3"; letter = yytext();
            }
          // fall through
          case 98: break;
          case 36:
            { latin = "-TER";
            }
          // fall through
          case 99: break;
          case 37:
            { tipoAllegato = "ALLEGATO";
            }
          // fall through
          case 100: break;
          case 38:
            { latin = "-SEMEL";
            }
          // fall through
          case 101: break;
          case 39:
            { latin = "-DECIES";
            }
          // fall through
          case 102: break;
          case 40:
            { latin = "-NOVIES";
            }
          // fall through
          case 103: break;
          case 41:
            { latin = "-OCTIES";
            }
          // fall through
          case 104: break;
          case 42:
            { latin = "-QUATER";
            }
          // fall through
          case 105: break;
          case 43:
            { latin = "-SEXIES";
            }
          // fall through
          case 106: break;
          case 44:
            { latin = "-VICIES";
            }
          // fall through
          case 107: break;
          case 45:
            { latin = "-SEPTIES";
            }
          // fall through
          case 108: break;
          case 46:
            { tipoAllegato = "TABELLA";
            }
          // fall through
          case 109: break;
          case 47:
            { tipoAllegato = "TARIFFA";
            }
          // fall through
          case 110: break;
          case 48:
            { latin = "-UNDECIES";
            }
          // fall through
          case 111: break;
          case 49:
            { latin = "-UNVICIES";
            }
          // fall through
          case 112: break;
          case 50:
            { latin = "-DUODECIES";
            }
          // fall through
          case 113: break;
          case 51:
            { latin = "-DUOVICIES";
            }
          // fall through
          case 114: break;
          case 52:
            { latin = "-QUINQUIES";
            }
          // fall through
          case 115: break;
          case 53:
            { latin = "-SEXDECIES";
            }
          // fall through
          case 116: break;
          case 54:
            { latin = "-TERDECIES";
            }
          // fall through
          case 117: break;
          case 55:
            { latin = "-TERVICIES";
            }
          // fall through
          case 118: break;
          case 56:
            { latin = "-NOVODECIES";
            }
          // fall through
          case 119: break;
          case 57:
            { latin = "-OCTODECIES";
            }
          // fall through
          case 120: break;
          case 58:
            { tipoAllegato = "PROTOCOLLO";
            }
          // fall through
          case 121: break;
          case 59:
            { latin = "-QUINDECIES";
            }
          // fall through
          case 122: break;
          case 60:
            { latin = "-QUINVICIES";
            }
          // fall through
          case 123: break;
          case 61:
            { latin = "-SEPTDECIES";
            }
          // fall through
          case 124: break;
          case 62:
            { latin = "-QUATERDECIES";
            }
          // fall through
          case 125: break;
          case 63:
            { latin = "-QUATERVICIES";
            }
          // fall through
          case 126: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java ValueReader [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        ValueReader scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new ValueReader(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
